#include<cstdio>
#include<map>
#include<algorithm>

using std::map;
using std::lower_bound;

struct tablaitem{long x, y, z;};

bool operator<(const tablaitem & ti, int x) {
	return ti.x<x;
}

int main() {
	long M = 0;
	long Q = 0;
	while(scanf("%ld %ld", &M, &Q)==2) {
		if(M==0 && Q==0) break;
		
		long start = 0;
		map<long, long> idx;
		tablaitem * tabla = new tablaitem[M];
		long tablameret = 0;
		
		for(long i=0;i<M;i++) {
			long K;
			scanf("%ld", &K);
			if(idx.find(K)!=idx.end() && idx[K]>=start) {
				start = idx[K]+1;
				tabla[tablameret].x = idx[K];
				tabla[tablameret].y = i;
				tabla[tablameret].z = K;
				tablameret++;
			}
			idx[K]=i;
		}
		
		for(long i=0; i<Q; i++) {
			long a, b;
			scanf("%ld %ld", &a, &b);
			a--; b--; //korrekci
			tablaitem * rec = lower_bound(tabla, tabla+tablameret, a);
			if(rec>=tabla+tablameret) {
				printf("OK1\n");
			} else {
				if(rec->x > b) {
					printf("OK2\n");
				} else {
					if(rec->y >= a && rec->y <= b) {
						printf("%ld\n", rec->z);
					} else {
						printf("OK3\n");
					}
				}
			}
		}
		printf("\n");
	}
	return 0;
}